diff --git a/src/main/java/info/magnolia/module/resources/ResourceTypes.java b/src/main/java/info/magnolia/module/resources/ResourceTypes.java
index 413be16..a225248 100644
--- a/src/main/java/info/magnolia/module/resources/ResourceTypes.java
+++ b/src/main/java/info/magnolia/module/resources/ResourceTypes.java
@@ -33,11 +33,11 @@
  */
 package info.magnolia.module.resources;
 
+import org.apache.commons.lang.StringUtils;
+
 import java.util.Arrays;
 import java.util.List;
 
-import org.apache.commons.lang.StringUtils;
-
 /**
  * Constants for resource types.
  */
@@ -52,6 +52,8 @@ public final class ResourceTypes {
 
     public static final String JS_SUFFIX = "js";
 
+    public static final String HTML_SUFFIX = "html";
+
     public static final String PROCESSED_JS_SUFFIX = "processedJs";
 
     public static final String BINARY_SUFFIX = "binary";
@@ -61,7 +63,9 @@ public final class ResourceTypes {
 
     public static final String CSS = RESOURCES_PREFIX + CSS_SUFFIX;
 
-    public static final String JS = RESOURCES_PREFIX + "js";
+    public static final String JS = RESOURCES_PREFIX + JS_SUFFIX;
+
+    public static final String HTML = RESOURCES_PREFIX + HTML_SUFFIX;
 
     public static final String PROCESSED_CSS = RESOURCES_PREFIX + PROCESSED_CSS_SUFFIX;
 
@@ -70,7 +74,7 @@ public final class ResourceTypes {
     public static final String BINARY = RESOURCES_PREFIX + BINARY_SUFFIX;
 
 
-    private static final List<String> nonBinaryResources = Arrays.asList(new String[] { "css", "js" });
+    private static final List<String> nonBinaryResources = Arrays.asList(new String[]{"css", "js", "html"});
 
     public static String determineType(String resource) {
         return ResourceTypes.determineType(resource, true); // processed by default
diff --git a/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.apps.xml b/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.apps.xml
index 038eb7c..fb605b7 100644
--- a/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.apps.xml
+++ b/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.apps.xml
@@ -381,6 +381,9 @@
               <sv:property sv:name="css" sv:type="String">
                 <sv:value>css</sv:value>
               </sv:property>
+              <sv:property sv:name="html" sv:type="String">
+                <sv:value>html</sv:value>
+              </sv:property>
               <sv:property sv:name="jcr:createdBy" sv:type="String">
                 <sv:value>admin</sv:value>
               </sv:property>
@@ -394,7 +397,7 @@
                 <sv:value>superuser</sv:value>
               </sv:property>
               <sv:property sv:name="mgnl:lastModified" sv:type="Date">
-                <sv:value>2013-10-11T11:38:36.681Z</sv:value>
+                <sv:value>2014-04-26T00:41:24.529+02:00</sv:value>
               </sv:property>
               <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
                 <sv:value>superuser</sv:value>
@@ -6713,6 +6716,41 @@
                             <sv:value>resources:reference</sv:value>
                           </sv:property>
                         </sv:node>
+                        <sv:node sv:name="html">
+                          <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                            <sv:value>mgnl:contentNode</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="jcr:uuid" sv:type="String">
+                            <sv:value>d867bf66-53c8-4523-ad05-be09c96d40ec</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="jcr:createdBy" sv:type="String">
+                            <sv:value>admin</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+                            <sv:value>false</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="mgnl:created" sv:type="Date">
+                            <sv:value>2014-04-26T01:12:39.215+02:00</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="mgnl:createdBy" sv:type="String">
+                            <sv:value>superuser</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+                            <sv:value>2014-04-26T01:12:39.215+02:00</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+                            <sv:value>superuser</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+                            <sv:value>2014-04-26T01:12:53.246+02:00</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+                            <sv:value>superuser</sv:value>
+                          </sv:property>
+                          <sv:property sv:name="value" sv:type="String">
+                            <sv:value>resources:html</sv:value>
+                          </sv:property>
+                        </sv:node>
                       </sv:node>
                     </sv:node>
                   </sv:node>
@@ -7235,6 +7273,251 @@
           </sv:node>
         </sv:node>
       </sv:node>
+      <sv:node sv:name="html">
+        <sv:property sv:name="jcr:primaryType" sv:type="Name">
+          <sv:value>mgnl:contentNode</sv:value>
+        </sv:property>
+        <sv:property sv:name="jcr:mixinTypes" sv:type="Name" sv:multiple="true">
+          <sv:value>mix:lockable</sv:value>
+        </sv:property>
+        <sv:property sv:name="jcr:uuid" sv:type="String">
+          <sv:value>d4325fb6-bf17-4f3f-a56b-020cc32342ef</sv:value>
+        </sv:property>
+        <sv:property sv:name="extends" sv:type="String">
+          <sv:value>../generic/code</sv:value>
+        </sv:property>
+        <sv:property sv:name="jcr:createdBy" sv:type="String">
+          <sv:value>admin</sv:value>
+        </sv:property>
+        <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+          <sv:value>false</sv:value>
+        </sv:property>
+        <sv:property sv:name="mgnl:created" sv:type="Date">
+          <sv:value>2014-04-26T00:20:24.010+02:00</sv:value>
+        </sv:property>
+        <sv:property sv:name="mgnl:createdBy" sv:type="String">
+          <sv:value>superuser</sv:value>
+        </sv:property>
+        <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+          <sv:value>2014-04-26T00:20:24.032+02:00</sv:value>
+        </sv:property>
+        <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+          <sv:value>superuser</sv:value>
+        </sv:property>
+        <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+          <sv:value>2014-04-29T01:05:12.014+02:00</sv:value>
+        </sv:property>
+        <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+          <sv:value>superuser</sv:value>
+        </sv:property>
+        <sv:node sv:name="editor">
+          <sv:property sv:name="jcr:primaryType" sv:type="Name">
+            <sv:value>mgnl:contentNode</sv:value>
+          </sv:property>
+          <sv:property sv:name="jcr:mixinTypes" sv:type="Name" sv:multiple="true">
+            <sv:value>mix:lockable</sv:value>
+          </sv:property>
+          <sv:property sv:name="jcr:uuid" sv:type="String">
+            <sv:value>46c111a9-ac20-4a87-ae07-1c8bd4c114a8</sv:value>
+          </sv:property>
+          <sv:property sv:name="jcr:createdBy" sv:type="String">
+            <sv:value>admin</sv:value>
+          </sv:property>
+          <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+            <sv:value>false</sv:value>
+          </sv:property>
+          <sv:property sv:name="mgnl:created" sv:type="Date">
+            <sv:value>2014-04-26T00:20:24.010+02:00</sv:value>
+          </sv:property>
+          <sv:property sv:name="mgnl:createdBy" sv:type="String">
+            <sv:value>superuser</sv:value>
+          </sv:property>
+          <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+            <sv:value>2014-04-26T00:20:24.032+02:00</sv:value>
+          </sv:property>
+          <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+            <sv:value>superuser</sv:value>
+          </sv:property>
+          <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+            <sv:value>2014-04-29T01:05:12.014+02:00</sv:value>
+          </sv:property>
+          <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+            <sv:value>superuser</sv:value>
+          </sv:property>
+          <sv:node sv:name="form">
+            <sv:property sv:name="jcr:primaryType" sv:type="Name">
+              <sv:value>mgnl:contentNode</sv:value>
+            </sv:property>
+            <sv:property sv:name="jcr:mixinTypes" sv:type="Name" sv:multiple="true">
+              <sv:value>mix:lockable</sv:value>
+            </sv:property>
+            <sv:property sv:name="jcr:uuid" sv:type="String">
+              <sv:value>96df45c5-9506-4445-8e75-c2f2bc33a9a7</sv:value>
+            </sv:property>
+            <sv:property sv:name="jcr:createdBy" sv:type="String">
+              <sv:value>admin</sv:value>
+            </sv:property>
+            <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+              <sv:value>false</sv:value>
+            </sv:property>
+            <sv:property sv:name="mgnl:created" sv:type="Date">
+              <sv:value>2014-04-26T00:20:24.010+02:00</sv:value>
+            </sv:property>
+            <sv:property sv:name="mgnl:createdBy" sv:type="String">
+              <sv:value>superuser</sv:value>
+            </sv:property>
+            <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+              <sv:value>2014-04-26T00:20:24.032+02:00</sv:value>
+            </sv:property>
+            <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+              <sv:value>superuser</sv:value>
+            </sv:property>
+            <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+              <sv:value>2014-04-29T01:05:12.014+02:00</sv:value>
+            </sv:property>
+            <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+              <sv:value>superuser</sv:value>
+            </sv:property>
+            <sv:node sv:name="tabs">
+              <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                <sv:value>mgnl:contentNode</sv:value>
+              </sv:property>
+              <sv:property sv:name="jcr:mixinTypes" sv:type="Name" sv:multiple="true">
+                <sv:value>mix:lockable</sv:value>
+              </sv:property>
+              <sv:property sv:name="jcr:uuid" sv:type="String">
+                <sv:value>fc9ee924-b05e-44cd-b73a-57acdb3dbd75</sv:value>
+              </sv:property>
+              <sv:property sv:name="jcr:createdBy" sv:type="String">
+                <sv:value>admin</sv:value>
+              </sv:property>
+              <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+                <sv:value>false</sv:value>
+              </sv:property>
+              <sv:property sv:name="mgnl:created" sv:type="Date">
+                <sv:value>2014-04-26T00:20:24.010+02:00</sv:value>
+              </sv:property>
+              <sv:property sv:name="mgnl:createdBy" sv:type="String">
+                <sv:value>superuser</sv:value>
+              </sv:property>
+              <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+                <sv:value>2014-04-26T00:20:24.033+02:00</sv:value>
+              </sv:property>
+              <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+                <sv:value>superuser</sv:value>
+              </sv:property>
+              <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+                <sv:value>2014-04-29T01:05:12.014+02:00</sv:value>
+              </sv:property>
+              <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+                <sv:value>superuser</sv:value>
+              </sv:property>
+              <sv:node sv:name="content">
+                <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                  <sv:value>mgnl:contentNode</sv:value>
+                </sv:property>
+                <sv:property sv:name="jcr:mixinTypes" sv:type="Name" sv:multiple="true">
+                  <sv:value>mix:lockable</sv:value>
+                </sv:property>
+                <sv:property sv:name="jcr:uuid" sv:type="String">
+                  <sv:value>357c1b91-93be-451b-b205-4c07f17f0d61</sv:value>
+                </sv:property>
+                <sv:property sv:name="jcr:createdBy" sv:type="String">
+                  <sv:value>admin</sv:value>
+                </sv:property>
+                <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+                  <sv:value>false</sv:value>
+                </sv:property>
+                <sv:property sv:name="mgnl:created" sv:type="Date">
+                  <sv:value>2014-04-26T00:20:24.010+02:00</sv:value>
+                </sv:property>
+                <sv:property sv:name="mgnl:createdBy" sv:type="String">
+                  <sv:value>superuser</sv:value>
+                </sv:property>
+                <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+                  <sv:value>2014-04-26T00:20:24.033+02:00</sv:value>
+                </sv:property>
+                <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+                  <sv:value>superuser</sv:value>
+                </sv:property>
+                <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+                  <sv:value>2014-04-29T01:05:12.014+02:00</sv:value>
+                </sv:property>
+                <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+                  <sv:value>superuser</sv:value>
+                </sv:property>
+                <sv:node sv:name="fields">
+                  <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                    <sv:value>mgnl:contentNode</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="jcr:uuid" sv:type="String">
+                    <sv:value>0ebf0225-fb08-4fa6-993f-8ed5cb89ced6</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="jcr:createdBy" sv:type="String">
+                    <sv:value>admin</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+                    <sv:value>false</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:created" sv:type="Date">
+                    <sv:value>2014-04-26T00:20:24.010+02:00</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:createdBy" sv:type="String">
+                    <sv:value>superuser</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+                    <sv:value>2014-04-26T00:20:24.034+02:00</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+                    <sv:value>superuser</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+                    <sv:value>2014-04-29T01:05:12.014+02:00</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+                    <sv:value>superuser</sv:value>
+                  </sv:property>
+                  <sv:node sv:name="text">
+                    <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                      <sv:value>mgnl:contentNode</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="jcr:uuid" sv:type="String">
+                      <sv:value>66440582-edec-40ec-8424-345e3f056d25</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="jcr:createdBy" sv:type="String">
+                      <sv:value>admin</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="language" sv:type="String">
+                      <sv:value>html</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+                      <sv:value>false</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="mgnl:created" sv:type="Date">
+                      <sv:value>2014-04-26T00:20:24.010+02:00</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="mgnl:createdBy" sv:type="String">
+                      <sv:value>superuser</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+                      <sv:value>2014-04-26T00:20:24.035+02:00</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+                      <sv:value>superuser</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+                      <sv:value>2014-04-29T01:05:12.014+02:00</sv:value>
+                    </sv:property>
+                    <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+                      <sv:value>superuser</sv:value>
+                    </sv:property>
+                  </sv:node>
+                </sv:node>
+              </sv:node>
+            </sv:node>
+          </sv:node>
+        </sv:node>
+      </sv:node>
     </sv:node>
   </sv:node>
 </sv:node>
diff --git a/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.dialogs.xml b/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.dialogs.xml
index d99859f..fa92cd1 100644
--- a/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.dialogs.xml
+++ b/src/main/resources/mgnl-bootstrap/resources/app/config.modules.resources.dialogs.xml
@@ -464,6 +464,41 @@
                     <sv:value>resources:reference</sv:value>
                   </sv:property>
                 </sv:node>
+                <sv:node sv:name="html">
+                  <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                    <sv:value>mgnl:contentNode</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="jcr:uuid" sv:type="String">
+                    <sv:value>4b306a0a-a5b4-4aea-8490-5514a1aea7a9</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="jcr:createdBy" sv:type="String">
+                    <sv:value>admin</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+                    <sv:value>false</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:created" sv:type="Date">
+                    <sv:value>2014-04-26T00:00:22.771+02:00</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:createdBy" sv:type="String">
+                    <sv:value>superuser</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+                    <sv:value>2014-04-26T00:00:22.775+02:00</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+                    <sv:value>superuser</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+                    <sv:value>2014-04-26T00:00:32.567+02:00</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+                    <sv:value>superuser</sv:value>
+                  </sv:property>
+                  <sv:property sv:name="value" sv:type="String">
+                    <sv:value>resources:html</sv:value>
+                  </sv:property>
+                </sv:node>
               </sv:node>
             </sv:node>
           </sv:node>
diff --git a/src/main/resources/mgnl-bootstrap/resources/templates/config.modules.resources.templates.html.xml b/src/main/resources/mgnl-bootstrap/resources/templates/config.modules.resources.templates.html.xml
new file mode 100644
index 0000000..0c44db5
--- /dev/null
+++ b/src/main/resources/mgnl-bootstrap/resources/templates/config.modules.resources.templates.html.xml
@@ -0,0 +1,51 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<sv:node sv:name="html" xmlns:sv="http://www.jcp.org/jcr/sv/1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+  <sv:property sv:name="jcr:primaryType" sv:type="Name">
+    <sv:value>mgnl:contentNode</sv:value>
+  </sv:property>
+  <sv:property sv:name="jcr:uuid" sv:type="String">
+    <sv:value>141b546f-a88e-479a-9a17-3b10e0b7c96f</sv:value>
+  </sv:property>
+  <sv:property sv:name="class" sv:type="String">
+    <sv:value>info.magnolia.module.resources.templates.ResourceTemplate</sv:value>
+  </sv:property>
+  <sv:property sv:name="contentType" sv:type="String">
+    <sv:value>text/html</sv:value>
+  </sv:property>
+  <sv:property sv:name="dialog" sv:type="String">
+    <sv:value>resources:text</sv:value>
+  </sv:property>
+  <sv:property sv:name="jcr:createdBy" sv:type="String">
+    <sv:value>admin</sv:value>
+  </sv:property>
+  <sv:property sv:name="mgnl:activationStatus" sv:type="Boolean">
+    <sv:value>false</sv:value>
+  </sv:property>
+  <sv:property sv:name="mgnl:created" sv:type="Date">
+    <sv:value>2014-04-26T02:06:30.101+02:00</sv:value>
+  </sv:property>
+  <sv:property sv:name="mgnl:createdBy" sv:type="String">
+    <sv:value>superuser</sv:value>
+  </sv:property>
+  <sv:property sv:name="mgnl:lastActivated" sv:type="Date">
+    <sv:value>2014-04-26T02:06:30.103+02:00</sv:value>
+  </sv:property>
+  <sv:property sv:name="mgnl:lastActivatedBy" sv:type="String">
+    <sv:value>superuser</sv:value>
+  </sv:property>
+  <sv:property sv:name="mgnl:lastModified" sv:type="Date">
+    <sv:value>2014-04-26T02:06:52.741+02:00</sv:value>
+  </sv:property>
+  <sv:property sv:name="mgnl:lastModifiedBy" sv:type="String">
+    <sv:value>superuser</sv:value>
+  </sv:property>
+  <sv:property sv:name="processed" sv:type="Boolean">
+    <sv:value>false</sv:value>
+  </sv:property>
+  <sv:property sv:name="renderType" sv:type="String">
+    <sv:value>textResource</sv:value>
+  </sv:property>
+  <sv:property sv:name="title" sv:type="String">
+    <sv:value>HTML</sv:value>
+  </sv:property>
+</sv:node>
diff --git a/src/main/resources/mgnl-i18n/app-resources-messages_en.properties b/src/main/resources/mgnl-i18n/app-resources-messages_en.properties
index 9e9d293..84cd5d2 100644
--- a/src/main/resources/mgnl-i18n/app-resources-messages_en.properties
+++ b/src/main/resources/mgnl-i18n/app-resources-messages_en.properties
@@ -33,6 +33,7 @@ resources.content.mgnl-template.options.processedJs         = Processed Javascri
 resources.content.mgnl-template.options.binary              = Binary
 resources.content.mgnl-template.options.binary.extension    = Binary/{0}
 resources.content.mgnl-template.options.reference           = Reference
+resources.content.mgnl-template.options.html                = HTML
 
 
 resources.advanced                                          = Advanced
@@ -60,6 +61,7 @@ resources.newResource.content.mgnl-template.options.js                  = Javasc
 resources.newResource.content.mgnl-template.options.processedJavascript = Processed Javascript
 resources.newResource.content.mgnl-template.options.binary              = Binary
 resources.newResource.content.mgnl-template.options.reference           = Reference
+resources.newResource.content.mgnl-template.options.html                = HTML
 
 resources.editTemplate.tabTemplate.mgnl-template.options.css            = CSS
 resources.editTemplate.tabTemplate.mgnl-template.options.processedCss   = Processed CSS
@@ -67,6 +69,7 @@ resources.editTemplate.tabTemplate.mgnl-template.options.js             = Javasc
 resources.editTemplate.tabTemplate.mgnl-template.options.processedJavascript = Processed Javascript
 resources.editTemplate.tabTemplate.mgnl-template.options.binary         = Binary
 resources.editTemplate.tabTemplate.mgnl-template.options.reference      = Reference
+resources.editTemplate.tabTemplate.mgnl-template.options.html           = HTML
 
 resources.editTemplate.label=Change Template
 resources.editTemplate.tabTemplate=