From 2cfba97c66b526e293d5946defc6df6ca8ec97a3 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Robert=20=C5=A0i=C5=A1ka?= <robert.siska@magnolia-cms.com>
Date: Thu, 29 Oct 2015 14:18:28 +0100
Subject: [PATCH] patch

---
 .../info/magnolia/setup/CoreModuleVersionHandler.java   |  4 ++--
 .../mgnl-bootstrap/core/config.server.filters.xml       | 17 +++++++++++++++++
 .../resources/mgnl-nodetypes/magnolia-nodetypes.xml     | 15 ---------------
 3 files changed, 19 insertions(+), 17 deletions(-)

diff --git a/magnolia-core/src/main/java/info/magnolia/setup/CoreModuleVersionHandler.java b/magnolia-core/src/main/java/info/magnolia/setup/CoreModuleVersionHandler.java
index b023346..b00d6f4 100644
--- a/magnolia-core/src/main/java/info/magnolia/setup/CoreModuleVersionHandler.java
+++ b/magnolia-core/src/main/java/info/magnolia/setup/CoreModuleVersionHandler.java
@@ -229,8 +229,8 @@ public class CoreModuleVersionHandler extends AbstractModuleVersionHandler {
         // always hash passwords. Task will not re-hash so it is safe to run this op at any time, multiple times.
         tasks.add(new HashUsersPasswords());
         tasks.add(bootstrapChannelManagement);
-        tasks.add(bootstrapChannelFilter);
-        tasks.add(placeChannelBeforeLogout);
+        //tasks.add(bootstrapChannelFilter);
+        //tasks.add(placeChannelBeforeLogout);
 
         return tasks;
     }
diff --git a/magnolia-core/src/main/resources/mgnl-bootstrap/core/config.server.filters.xml b/magnolia-core/src/main/resources/mgnl-bootstrap/core/config.server.filters.xml
index 4fd41d6..789cff2 100644
--- a/magnolia-core/src/main/resources/mgnl-bootstrap/core/config.server.filters.xml
+++ b/magnolia-core/src/main/resources/mgnl-bootstrap/core/config.server.filters.xml
@@ -142,6 +142,23 @@
       </sv:node>
     </sv:node>
   </sv:node>
+  <sv:node sv:name="channel">
+    <sv:property sv:name="jcr:primaryType" sv:type="Name">
+      <sv:value>mgnl:content</sv:value>
+    </sv:property>
+    <sv:property sv:name="jcr:uuid" sv:type="String">
+      <sv:value>b2fafa53-fc7b-4835-ae1b-7ed879cd4001</sv:value>
+    </sv:property>
+    <sv:property sv:name="class" sv:type="String">
+      <sv:value>info.magnolia.cms.filters.MultiChannelFilter</sv:value>
+    </sv:property>
+    <sv:property sv:name="enabled" sv:type="Boolean">
+      <sv:value>true</sv:value>
+    </sv:property>
+    <sv:property sv:name="jcr:createdBy" sv:type="String">
+      <sv:value>admin</sv:value>
+    </sv:property>
+  </sv:node>
   <sv:node sv:name="logout">
     <sv:property sv:name="jcr:primaryType" sv:type="Name">
       <sv:value>mgnl:content</sv:value>
diff --git a/magnolia-core/src/main/resources/mgnl-nodetypes/magnolia-nodetypes.xml b/magnolia-core/src/main/resources/mgnl-nodetypes/magnolia-nodetypes.xml
index dd4f52e..35f0360 100644
--- a/magnolia-core/src/main/resources/mgnl-nodetypes/magnolia-nodetypes.xml
+++ b/magnolia-core/src/main/resources/mgnl-nodetypes/magnolia-nodetypes.xml
@@ -79,41 +79,26 @@
   </nodeType>
 
   <nodeType name="mgnl:lastModified" isMixin="true">
-    <supertypes>
-      <supertype>nt:base</supertype>
-    </supertypes>
     <propertyDefinition name="mgnl:lastModified" requiredType="Date" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
     <propertyDefinition name="mgnl:lastModifiedBy" requiredType="String" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
   </nodeType>
 
   <nodeType name="mgnl:activatable" isMixin="true">
-    <supertypes>
-      <supertype>nt:base</supertype>
-    </supertypes>
     <propertyDefinition name="mgnl:lastActivated" requiredType="Date" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
     <propertyDefinition name="mgnl:lastActivatedBy" requiredType="String" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
     <propertyDefinition name="mgnl:activationStatus" requiredType="String" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
   </nodeType>
 
   <nodeType name="mgnl:renderable" isMixin="true">
-    <supertypes>
-      <supertype>nt:base</supertype>
-    </supertypes>
     <propertyDefinition name="mgnl:template" requiredType="String" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
   </nodeType>
 
   <nodeType name="mgnl:created" isMixin="true">
-    <supertypes>
-      <supertype>nt:base</supertype>
-    </supertypes>
     <propertyDefinition name="mgnl:created" requiredType="Date" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
     <propertyDefinition name="mgnl:createdBy" requiredType="String" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
   </nodeType>
 
   <nodeType name="mgnl:versionable" isMixin="true">
-    <supertypes>
-      <supertype>nt:base</supertype>
-    </supertypes>
     <propertyDefinition name="mgnl:comment" requiredType="String" autoCreated="false" mandatory="false" onParentVersion="COPY" protected="false" multiple="false"/>
   </nodeType>
 
-- 
2.4.3