diff --git a/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppPresenter.java b/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppPresenter.java
index 9a9d0c6..f1a5e7e 100644
--- a/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppPresenter.java
+++ b/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppPresenter.java
@@ -55,11 +55,11 @@ import javax.jcr.RepositoryException;
 
 import org.apache.commons.lang3.ClassUtils;
 import org.apache.commons.lang3.StringUtils;
-import org.codehaus.jackson.JsonNode;
-import org.codehaus.jackson.map.ObjectMapper;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
+import com.fasterxml.jackson.databind.JsonNode;
+import com.fasterxml.jackson.databind.ObjectMapper;
 import com.google.common.base.Splitter;
 import com.vaadin.data.util.ObjectProperty;
 import com.vaadin.data.util.PropertysetItem;
diff --git a/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppViewImpl.java b/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppViewImpl.java
index 8bfa42d..8bffea2 100644
--- a/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppViewImpl.java
+++ b/magnolia-rest-client-app/src/main/java/info/magnolia/rest/client/app/ui/RestClientAppViewImpl.java
@@ -54,13 +54,13 @@ import javax.ws.rs.ClientErrorException;
 
 import org.apache.commons.lang3.StringUtils;
 import org.apache.commons.lang3.exception.ExceptionUtils;
-import org.codehaus.jackson.JsonNode;
-import org.codehaus.jackson.map.ObjectMapper;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 import org.vaadin.aceeditor.AceEditor;
 import org.vaadin.aceeditor.AceMode;
 
+import com.fasterxml.jackson.databind.JsonNode;
+import com.fasterxml.jackson.databind.ObjectMapper;
 import com.vaadin.data.Item;
 import com.vaadin.data.Property;
 import com.vaadin.data.fieldgroup.FieldGroup;
diff --git a/magnolia-resteasy-client/pom.xml b/magnolia-resteasy-client/pom.xml
index 785159e..1157a52 100644
--- a/magnolia-resteasy-client/pom.xml
+++ b/magnolia-resteasy-client/pom.xml
@@ -30,7 +30,7 @@
 
     <dependency>
       <groupId>org.jboss.resteasy</groupId>
-      <artifactId>resteasy-jackson-provider</artifactId>
+      <artifactId>resteasy-jackson2-provider</artifactId>
     </dependency>
 
     <dependency>
diff --git a/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommand.java b/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommand.java
index 728b673..d3fbe7f 100644
--- a/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommand.java
+++ b/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommand.java
@@ -48,7 +48,7 @@ import javax.ws.rs.NotAuthorizedException;
 import javax.ws.rs.WebApplicationException;
 import javax.ws.rs.core.MediaType;
 
-import org.codehaus.jackson.JsonNode;
+import com.fasterxml.jackson.databind.JsonNode;
 
 /**
  * Abstract command which catches {@link WebApplicationException} to provide proper message from JSON response and also provides method to reauthenticate admin user.
diff --git a/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctions.java b/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctions.java
index 80b66df..e1a78c3 100644
--- a/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctions.java
+++ b/magnolia-resteasy-client/src/main/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctions.java
@@ -45,7 +45,7 @@ import java.util.HashSet;
 import javax.inject.Inject;
 import javax.ws.rs.ClientErrorException;
 
-import org.codehaus.jackson.node.ObjectNode;
+import com.fasterxml.jackson.databind.node.ObjectNode;
 
 /**
  * Templating functions for rest functions.
diff --git a/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommandTest.java b/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommandTest.java
index 0dd93bc..9c61c13 100644
--- a/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommandTest.java
+++ b/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/command/AbstractRestEasyCommandTest.java
@@ -51,10 +51,11 @@ import java.util.concurrent.LinkedBlockingDeque;
 
 import javax.ws.rs.NotAuthorizedException;
 
-import org.codehaus.jackson.JsonNode;
-import org.codehaus.jackson.node.JsonNodeFactory;
 import org.junit.Test;
 
+import com.fasterxml.jackson.databind.JsonNode;
+import com.fasterxml.jackson.databind.node.JsonNodeFactory;
+
 /**
  * Tests for {@link AbstractRestEasyCommand}.
  */
diff --git a/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctionsTest.java b/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctionsTest.java
index 2f1f5cc..62f006e 100644
--- a/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctionsTest.java
+++ b/magnolia-resteasy-client/src/test/java/info/magnolia/resteasy/client/functions/RestTemplatingFunctionsTest.java
@@ -41,11 +41,12 @@ import info.magnolia.registry.RegistrationException;
 import info.magnolia.rest.client.registry.RestClientRegistry;
 import info.magnolia.resteasy.client.RestEasyClient;
 
-import org.codehaus.jackson.JsonNode;
-import org.codehaus.jackson.node.JsonNodeFactory;
 import org.junit.Before;
 import org.junit.Test;
 
+import com.fasterxml.jackson.databind.JsonNode;
+import com.fasterxml.jackson.databind.node.JsonNodeFactory;
+
 /**
  * Tests for {@link info.magnolia.resteasy.client.functions.RestTemplatingFunctions}.
  */
@@ -70,7 +71,7 @@ public class RestTemplatingFunctionsTest {
         JsonNode result = (JsonNode) functions.call(REST_CLIENT_NAME, DummyServiceClass.class.getName(), "dummyMethod", "someParameterValue");
 
         //THEN
-        assertThat(result.toString(), containsString(result.getTextValue()));
+        assertThat(result.toString(), containsString(result.textValue()));
     }
 
     @Test
diff --git a/pom.xml b/pom.xml
index 1afe2b3..edb44bf 100644
--- a/pom.xml
+++ b/pom.xml
@@ -83,7 +83,7 @@
 
       <dependency>
         <groupId>org.jboss.resteasy</groupId>
-        <artifactId>resteasy-jackson-provider</artifactId>
+        <artifactId>resteasy-jackson2-provider</artifactId>
         <version>${restEasyVersion}</version>
       </dependency>
 