diff --git a/magnolia-cache-browser-app/pom.xml b/magnolia-cache-browser-app/pom.xml
index f154e17..ba03b6b 100644
--- a/magnolia-cache-browser-app/pom.xml
+++ b/magnolia-cache-browser-app/pom.xml
@@ -76,7 +76,7 @@
     </dependency>
     <dependency>
       <groupId>org.jboss.resteasy</groupId>
-      <artifactId>resteasy-jackson-provider</artifactId>
+      <artifactId>resteasy-jackson2-provider</artifactId>
     </dependency>
 
     <dependency>
diff --git a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/CacheBrowserContainer.java b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/CacheBrowserContainer.java
index 44871d0..78c8094 100644
--- a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/CacheBrowserContainer.java
+++ b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/CacheBrowserContainer.java
@@ -57,11 +57,11 @@ import java.util.Set;
 import javax.ws.rs.ClientErrorException;
 
 import org.apache.commons.lang3.StringUtils;
-import org.codehaus.jackson.JsonNode;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
 import com.cedarsoftware.util.io.JsonReader;
+import com.fasterxml.jackson.databind.JsonNode;
 import com.google.common.cache.Cache;
 import com.google.common.cache.CacheBuilder;
 import com.vaadin.data.Container;
@@ -421,7 +421,7 @@ public class CacheBrowserContainer extends AbstractContainer implements Containe
             } catch (ClientErrorException e) {
                 if (e.getResponse().getEntity() != null && e.getResponse().getEntity() instanceof JsonNode) {
                     JsonNode errorNode = (JsonNode) e.getResponse().getEntity();
-                    log.warn("Error occurred while obtaining cache keys for cache {} from public instance {}: {}", contentConnectorDefinition.getCacheName(), entry.getKey(), errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).getTextValue());
+                    log.warn("Error occurred while obtaining cache keys for cache {} from public instance {}: {}", contentConnectorDefinition.getCacheName(), entry.getKey(), errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).textValue());
                 }
                 log.warn("Error occurred while obtaining cache keys for cache {} from public instance {}: {}", contentConnectorDefinition.getCacheName(), entry.getKey(), e.getMessage());
                 e.getResponse().close();
@@ -460,11 +460,11 @@ public class CacheBrowserContainer extends AbstractContainer implements Containe
             CacheService cacheService = entry.getValue();
             int newSize = 0;
             try {
-                newSize = cacheService.getCacheSize(contentConnectorDefinition.getCacheName()).get("size").getIntValue();
+                newSize = cacheService.getCacheSize(contentConnectorDefinition.getCacheName()).get("size").intValue();
             } catch (ClientErrorException e) {
                 if (e.getResponse().getEntity() != null && e.getResponse().getEntity() instanceof JsonNode) {
                     JsonNode errorNode = (JsonNode) e.getResponse().getEntity();
-                    log.warn("Error occurred while obtaining size of the cache with name {} from public instance {}: {}", contentConnectorDefinition.getCacheName(), entry.getKey(), errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).getTextValue());
+                    log.warn("Error occurred while obtaining size of the cache with name {} from public instance {}: {}", contentConnectorDefinition.getCacheName(), entry.getKey(), errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).textValue());
                 }
                 log.warn("Error occurred while obtaining size of the cache with name {} from public instance {}: {}", contentConnectorDefinition.getCacheName(), entry.getKey(), e.getMessage());
                 size = 0;
diff --git a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DeleteCacheEntryAction.java b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DeleteCacheEntryAction.java
index 1869ce8..9e1887c 100644
--- a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DeleteCacheEntryAction.java
+++ b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DeleteCacheEntryAction.java
@@ -49,7 +49,7 @@ import java.util.Map;
 import javax.inject.Named;
 import javax.ws.rs.ClientErrorException;
 
-import org.codehaus.jackson.JsonNode;
+import com.fasterxml.jackson.databind.JsonNode;
 
 import com.cedarsoftware.util.io.JsonWriter;
 import com.vaadin.data.Item;
@@ -84,7 +84,7 @@ public class DeleteCacheEntryAction extends AbstractMultiItemAction<DeleteCacheE
                     String errorMessage;
                     if (e.getResponse().getEntity() != null && e.getResponse().getEntity() instanceof JsonNode) {
                         JsonNode errorNode = (JsonNode) e.getResponse().getEntity();
-                        errorMessage = entry.getKey() + ": " + errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).getTextValue();
+                        errorMessage = entry.getKey() + ": " + errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).textValue();
                     } else {
                         errorMessage = entry.getKey() + ":" + e.getMessage();
                     }
diff --git a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DownloadCacheContentAction.java b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DownloadCacheContentAction.java
index 96e8fde..78b6579 100644
--- a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DownloadCacheContentAction.java
+++ b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/app/action/DownloadCacheContentAction.java
@@ -54,7 +54,7 @@ import javax.ws.rs.ClientErrorException;
 
 import org.apache.commons.io.IOUtils;
 import org.apache.commons.lang3.StringUtils;
-import org.codehaus.jackson.JsonNode;
+import com.fasterxml.jackson.databind.JsonNode;
 
 import com.cedarsoftware.util.io.JsonWriter;
 import com.vaadin.data.Item;
@@ -106,13 +106,13 @@ public class DownloadCacheContentAction extends AbstractMultiItemAction<Download
                         jsonNode = cacheService.getCacheContent(cacheKeyItem.getCacheName(), JsonWriter.objectToJson(cacheKeyItem.getItemId()));
                     } catch (ClientErrorException e) {
                         JsonNode errorNode = (JsonNode) e.getResponse().getEntity();
-                        throw new ActionExecutionException(errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).getTextValue());
+                        throw new ActionExecutionException(errorNode.get(CacheEndpoint.PROPERTY_ERROR_MESSAGE).textValue());
                     }
                     if (jsonNode.has(CacheEndpoint.PROPERTY_UNSUPPORTED_CACHED_ENTRY_TYPE)) {
-                        throw new ActionExecutionException(jsonNode.get(CacheEndpoint.PROPERTY_UNSUPPORTED_CACHED_ENTRY_TYPE).getTextValue());
+                        throw new ActionExecutionException(jsonNode.get(CacheEndpoint.PROPERTY_UNSUPPORTED_CACHED_ENTRY_TYPE).textValue());
                     }
-                    String originalUrl = jsonNode.get(CacheEndpoint.PROPERTY_ORIGINAL_URL).getTextValue();
-                    byte[] data = jsonNode.get(CacheEndpoint.PROPERTY_PLAIN_CONTENT).getBinaryValue();
+                    String originalUrl = jsonNode.get(CacheEndpoint.PROPERTY_ORIGINAL_URL).textValue();
+                    byte[] data = jsonNode.get(CacheEndpoint.PROPERTY_PLAIN_CONTENT).binaryValue();
                     String name = StringUtils.substringAfterLast(originalUrl, "/");
                     if (StringUtils.isBlank(name) || "/".equals(name)) {
                         name = DEFAULT_NAME;
diff --git a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/client/CacheService.java b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/client/CacheService.java
index e678a81..ab1471b 100644
--- a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/client/CacheService.java
+++ b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/client/CacheService.java
@@ -39,7 +39,7 @@ import javax.ws.rs.Path;
 import javax.ws.rs.PathParam;
 import javax.ws.rs.QueryParam;
 
-import org.codehaus.jackson.JsonNode;
+import com.fasterxml.jackson.databind.JsonNode;
 
 /**
  * Client service that connects to the {@link info.magnolia.cache.browser.rest.endpoint.CacheEndpoint}.
diff --git a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/endpoint/CacheEndpoint.java b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/endpoint/CacheEndpoint.java
index bda1fdb..1854685 100644
--- a/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/endpoint/CacheEndpoint.java
+++ b/magnolia-cache-browser-app/src/main/java/info/magnolia/cache/browser/rest/endpoint/CacheEndpoint.java
@@ -58,8 +58,8 @@ import javax.ws.rs.core.Response;
 
 import org.apache.commons.beanutils.BeanUtils;
 import org.apache.commons.lang3.StringUtils;
-import org.codehaus.jackson.node.JsonNodeFactory;
-import org.codehaus.jackson.node.ObjectNode;
+import com.fasterxml.jackson.databind.node.JsonNodeFactory;
+import com.fasterxml.jackson.databind.node.ObjectNode;
 
 import com.cedarsoftware.util.io.JsonIoException;
 import com.cedarsoftware.util.io.JsonReader;
diff --git a/pom.xml b/pom.xml
index 4440efd..f093fa9 100644
--- a/pom.xml
+++ b/pom.xml
@@ -61,7 +61,7 @@
       <dependency>
         <groupId>info.magnolia.rest</groupId>
         <artifactId>magnolia-rest</artifactId>
-        <version>1.2</version>
+        <version>1.2.1-SNAPSHOT</version>
         <type>pom</type>
         <scope>import</scope>
       </dependency>
@@ -87,7 +87,7 @@
       <dependency>
         <groupId>info.magnolia.restclient</groupId>
         <artifactId>magnolia-resteasy-client</artifactId>
-        <version>1.1</version>
+        <version>1.1.1-SNAPSHOT</version>
       </dependency>
 
       <!-- JSON-IO -->